#!/usr/bin/perl
# indexsoft mysql backups manager
# http://www.indexsoft.com

$|++;
$VER = '2.1 shareware';
eval('require "./backupsmanager.pm";');
$configerror = $@;
eval('use sendmail;');
$sendmailerror = $@;
eval('use Net::FTP;');
$ftperror = $@;
$document_root = $ENV{'DOCUMENT_ROOT'};
$document_root =~ s/\/$//g;
$document_root =~ s/\//\\/g if ($ENV{'WINDIR'});
$installdir = $ENV{'SCRIPT_FILENAME'};
$installdir =~ s/\/backupsmanager.cgi$//g;
$installdir =~ s/\//\\/g if ($ENV{'WINDIR'});
$rand = time;
$ENV{'DOCUMENT_ROOT'}?($cron = 0):($cron = 1);
&ReadParameters();
&DefineParams($P{'db'});

# if save config - save and reload
if (($P{'todo'} eq 'saveconfig') and $P{'cfgfilecontent'})
{
	$P{'cfgfilecontent'} =~ s/\r//g;
	open(FILE, ">backupsmanager.pm") || do { print &TopOfPage(); print &HoldError('can not rewrite configuration file <i>\'backupsmanager.pm\'</i>'); print &EditConfigForm(); print &BottomOfPage(); exit; };
	binmode('FILE');
	print FILE $P{'cfgfilecontent'};
	close FILE;
	print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nLocation: backupsmanager.cgi?todo=configure&db=$DB&saved=1\n\n};
	exit;
}
elsif ($P{'todo'} eq 'dumpanddownload' and $mySQLDBName)
{
	print &TopOfPage();
	print &Operation(qq{download disabled at shareware version. <a href="http://www.indexsoft.com/dbmanagerpro/">Please register</a><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>});
	print &ManageForm();
	print &BottomOfPage();
	exit;
}
elsif (($P{'todo'} eq 'downloadfile') and $P{'file'})
{
	print &TopOfPage();
	print &Operation(qq{download disabled at shareware version. <a href="http://www.indexsoft.com/dbmanagerpro/">Please register</a><SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Please register shareware');\n//-->\n</SCRIPT>});
	print &ManageForm();
	print &BottomOfPage();
	exit;
}

print &TopOfPage();

if (($P{'todo'} eq 'commandline'))
{
	print &CommandLine();
}
elsif (($P{'todo'} eq 'checkver'))
{
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=backupsmanager&ver=$VER&r=$rand" width="550" height="100" marginwidth="0" marginheight="0" scrolling="no" frameborder="0">
		<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" src="http://www.indexsoft.com/checkver.px?program=backupsmanager&ver=$VER&r=$rand&method=javascript"></SCRIPT>
		</iframe></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}
elsif (($P{'todo'} eq 'configure') or $configerror)
{
	print &Operation('save configuration file') if $P{'saved'};
	print &EditConfigForm();
}
elsif (($P{'todo'} eq 'packfile') and $P{'file'} and $mySQLDBName)
{
	print &Operation("pack file <i>'$P{'file'}'</i> to <i>'$P{'file'}.$ArchiveExt'</i>");
	$cmd = qq{$ArchiverCommand};
	$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$P{'file'}.".$ArchiveExt"/ge;
	$cmd =~ s/%f%/$iDBDumpsDir.$DirSeparator.$P{'file'}/ge;
	$code = system $cmd;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'unpackfile') and $P{'file'} and $mySQLDBName)
{
	print &Operation("unpack file <i>'$P{'file'}'</i>");
	$cmd = qq{$DeArchiverCommand};
	$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$P{'file'}/ge;
	$cmd =~ s/%p%/$iDBDumpsDir.$DirSeparator/ge;
	$code = system $cmd;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'ftpfile') and $P{'files'})
{
	print &Operation("upload files to FTP server <i>'$P{'ftpserver'}'</i>");
	grep(push (@files, "$iDBDumpsDir$DirSeparator$_"), split(/\0/, $P{'files'}));
	$code = &FTPFile($P{'ftpserver'}, $P{'ftpport'}, $P{'ftppath'}, $P{'ftplogin'}, $P{'ftppass'}, @files);
	print &HoldError("ftp session: $code") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'sendfile') and $P{'files'})
{
	print &Operation("send files to <i>'$P{'to'}'</i>");
	grep(push (@files, "$iDBDumpsDir$DirSeparator$_"), split(/\0/, $P{'files'}));
	$code = &SendFile($P{'from'}, $P{'to'}, $P{'subject'}, $P{'body'}, @files);
	print &HoldError("can not send email: <i>'$code'</i>") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'emailform') and $P{'files'} and $mySQLDBName)
{
	$files = '';
	grep($files .= qq{<input type="hidden" name="files" value="$_">} , split(/\0/, $P{'files'}));
	print &Header("Email backup files of database <i>'$mySQLDBName'</i>").qq{
	<p><form action="backupsmanager.cgi" method="post" name="sendform">
	<input type="hidden" name="todo" value="sendfile">
	<input type="hidden" name="db" value="$DB">
	$files
	<i>send message from:</i><br>
	<input type="text" name="from" value="$DefaultEmail" size="48" style="width: 320px;"><br>
	<i>send message to:</i><br>
	<input type="text" name="to" value="$DefaultEmail" size="48" style="width: 320px;" onclick="if (document.sendform.to.value == '$DefaultEmail') { document.sendform.to.value='' };"><br>
	<i>message subject:</i><br>
	<input type="text" name="subject" value="backups of database '$mySQLDBName'" size="48" style="width: 320px;"><br>
	<i>message body:</i><br>
	<textarea cols="38" rows="5" name="body" style="width: 320px;">Check out attachments with backups of database '$mySQLDBName'.</textarea><br><br>
	<input type="submit" value="Send file">
	</form></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>
	};
}
elsif (($P{'todo'} eq 'ftpform') and $P{'files'} and $mySQLDBName)
{
	$files = '';
	grep($files .= qq{<input type="hidden" name="files" value="$_">} , split(/\0/, $P{'files'}));
	print &Header("Upload backups files of database <i>'$mySQLDBName'</i> on FTP server").qq{
	<p><form action="backupsmanager.cgi" method="post">
	<input type="hidden" name="todo" value="ftpfile">
	<input type="hidden" name="db" value="$DB">
	$files
	<i>FTP server:</i><br>
	<input type="text" name="ftpserver" value="$DefaultFTP" size="48" style="width: 320px;"><br>
	<i>FTP server port:</i><br>
	<input type="text" name="ftpport" value="$DefaultFTPPort" size="48" style="width: 320px;"><br>
	<i>path on FTP server:</i><br>
	<input type="text" name="ftppath" value="$DefaultFTPPath" size="48" style="width: 320px;"><br>
	<i>login:</i><br>
	<input type="text" name="ftplogin" value="$DefaultFTPLogin" size="48" style="width: 320px;"><br>
	<i>password:</i><br>
	<input type="password" name="ftppass" value="$DefaultFTPPass" size="48" style="width: 320px;"><br><br>
	<input type="submit" value="FTP file">
	</form></p><p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>
	};
}
elsif (($P{'todo'} eq 'restore') and $P{'filename'} and $mySQLDBName)
{
	print &Operation("restore database <i>'$mySQLDBName'</i> from backup <i>'$P{'filename'}'</i>");
	$cmd = qq{$iRestoreDBCommand <"$iDBDumpsDir$DirSeparator$P{'filename'}"};
	$code = system $cmd;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	print &ManageForm();
}
elsif (($P{'todo'} eq 'delete') and $P{'files'} and $mySQLDBName)
{
	print &Operation("delete selected backups");
	foreach $file(split(/\0/, $P{'files'}))
	{
		if (-e "$iDBDumpsDir$DirSeparator$file") { unlink ("$iDBDumpsDir$DirSeparator$file") || print &HoldError("can not delete file <i>'$iDBDumpsDir$DirSeparator$file'</i>") };
	}
	print &ManageForm();
}
elsif (($P{'todo'} eq 'upload') and $P{'uploadfilename'} and $mySQLDBName)
{
	$filehandle = $MULTIPARTQUERY->param('uploadfilename');
	$filename = lc($P{'uploadfilename'});
	$filename =~ s!^.*(\\|\/)!!; 
	print &Operation("upload backup <i>'$filename'</i> for database <i>'$mySQLDBName'</i>");
	open(OUT, ">$iDBDumpsDir$DirSeparator$filename") || print &HoldError("can not save to file <i>'$iDBDumpsDir$DirSeparator$filename'</i>");
	binmode OUT;
	while (read($filehandle, $buffer, 1024))
	{
		print OUT $buffer;
	}
	close OUT;
	print &ManageForm();
}
elsif ($P{'todo'} eq 'backupall')
{
	if (!$P{'filename'}) { $filename = &TextDate(time).'(bulk).sql' } else { $filename = $P{'filename'}; $filename .= '.sql' if $filename !~ '.sql$'; };
	print &Operation("backup all existing databases with filename <i>'$filename'</i><br>".(($P{'packfile'})?("pack each file to <i>'$filename.$ArchiveExt'</i><br>"):('')).(($P{'emailfile'})?("email files to <i>'$DefaultEmail'</i><br>"):('')).(($P{'ftpfile'})?("upload them on FTP server <i>'$DefaultFTP'</i>"):('')));
	for ($i = 0; $i <= $#mySQLDBName; ++$i)
	{
		&DefineParams($i);
		$cmd = qq{$iDumpDBCommand >"$iDBDumpsDir$DirSeparator$filename"};
		$code = system $cmd;
		print &HoldError("command <i>$cmd</i> executed with error") if ($code);
		if ($P{'packfile'} and !$code)
		{
			$cmd = qq{$ArchiverCommand};
			$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$filename.".$ArchiveExt"/ge;
			$cmd =~ s/%f%/$iDBDumpsDir.$DirSeparator.$filename/ge;
			$code = system $cmd;
			print &HoldError("command <i>$cmd</i> executed with error") if ($code);
		}
		if ($P{'emailfile'} and !$code)
		{
			$code = &SendFile($DefaultEmail, $DefaultEmail, "backup of database '$mySQLDBName'", "Check out attachment with backup of database '$mySQLDBName'.", "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
			print &HoldError("can not send email: <i>'$code'</i>") if ($code);
		}
		if ($P{'ftpfile'} and !$code)
		{
			$code = &FTPFile($DefaultFTP, $DefaultFTPPort, $DefaultFTPPath, $DefaultFTPLogin, $DefaultFTPPass, "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
			print &HoldError("ftp session: $code") if ($code);
		}
	}
	&DefineParams($P{'db'});
	print &ManageForm();
}
elsif ($P{'todo'} eq 'dumpandsave' and $mySQLDBName)
{
	if (!$P{'filename'}) { $filename = &TextDate(time).'.sql' } else { $filename = $P{'filename'}; $filename .= '.sql' if $filename !~ '.sql$'; };
	print &Operation("backup database <i>'$mySQLDBName'</i> and save backup to file <i>'$filename'</i>");
	$cmd = qq{$iDumpDBCommand >"$iDBDumpsDir$DirSeparator$filename"};
	$code = system $cmd;
	print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	if ($P{'packfile'} and !$code)
	{
		print &Operation("pack file <i>'$filename'</i> to <i>'$filename.$ArchiveExt'</i>");
		$cmd = qq{$ArchiverCommand};
		$cmd =~ s/%a%/$iDBDumpsDir.$DirSeparator.$filename.".$ArchiveExt"/ge;
		$cmd =~ s/%f%/$iDBDumpsDir.$DirSeparator.$filename/ge;
		$code = system $cmd;
		print &HoldError("command <i>$cmd</i> executed with error") if ($code);
	}
	if ($P{'emailfile'} and !$code)
	{
		print &Operation("email file <i>'$filename".(($P{'packfile'})?(".$ArchiveExt"):(''))."'</i> to <i>'$DefaultEmail'</i>");
		$code = &SendFile($DefaultEmail, $DefaultEmail, "backup of database '$mySQLDBName'", "Check out attachment with backup of database '$mySQLDBName'.", "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
		print &HoldError("can not send email: <i>'$code'</i>") if ($code);
	}
	if ($P{'ftpfile'} and !$code)
	{
		print &Operation("upload file <i>'$filename".(($P{'packfile'})?(".$ArchiveExt"):(''))."'</i> to FTP server <i>'$DefaultFTP'</i>");
		$code = &FTPFile($DefaultFTP, $DefaultFTPPort, $DefaultFTPPath, $DefaultFTPLogin, $DefaultFTPPass, "$iDBDumpsDir$DirSeparator$filename".(($P{'packfile'})?(".$ArchiveExt"):('')));
		print &HoldError("ftp session: $code") if ($code);
	}
	print &ManageForm();
}
else
{
	print &ManageForm();
}

print &BottomOfPage();

#################################################################################
sub ManageForm
{
	return '' if $cron;
	my $filename = &TextDate(time);
	my ($result, $dbselect, $i) = ('','','');

	for ($i = 0; $i <= $#mySQLDBName; ++$i)	{ $dbselect .= qq{<option value="$i"}.(($DB eq $i)?' selected style="background-color: #FFFFFF;">':'>').qq{DB$i: $mySQLDBName[$i] (user $mySQLUser[$i] at $mySQLHost[$i])};}
	my $result = &Header('Select database for maintenance').qq{<p><form name="selectdbform" action="backupsmanager.cgi">
	<select name="db" style="width: 320px; background-color: #E0E0E0;" onchange="selectdbform.submit()">$dbselect</select> 
	<input type="submit" value="select database">
	</form>
	</p>};

	if ($mySQLDBName)
	{
		$result .= &Header("Backup database <i>'$mySQLDBName'</i>").qq{<p><form name="makedbdumpform" action="backupsmanager.cgi" method="post" target="_top">
		<input type="hidden" name="db" value="$DB">
		<ul>
		<li><input type="radio" name="todo" value="dumpanddownload" onclick="document.makedbdumpform.emailfile.disabled = true; document.makedbdumpform.ftpfile.disabled = true; document.makedbdumpform.packfile.disabled = true; document.makedbdumpform.filename.disabled = true; document.makedbdumpform.target = '_top'; "> backup and download it to my computer<br>
		<li><input type="radio" checked name="todo" value="dumpandsave" onclick="document.makedbdumpform.emailfile.disabled = false; document.makedbdumpform.ftpfile.disabled = false; document.makedbdumpform.packfile.disabled = false; document.makedbdumpform.filename.disabled = false; document.makedbdumpform.target = '_self'; "> backup and save it to file: <input type="text" name="filename" value="$filename.sql"><br>
		<input type="checkbox" name="packfile" value="1"> Pack file after saving
		<input type="checkbox" name="emailfile" value="1"> Email file
		<input type="checkbox" name="ftpfile" value="1"> Upload file on FTP server<br>
		</ul>
		<input type="submit" value="Backup">
		</form></p>
		<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
		<!--
		function AreYouSure()
		{
			if (document.selectdbdumpform.todo[0].checked) { return window.confirm('You about to restore database \\'$mySQLDBName\\' from backup.\\nAre you shure?') }
			else { return true; }
		}
		function Boxes(z)
		{
			var frm = document.selectdbdumpform;
			if (z == 'select')
			{
				if (frm.todo[0].checked) { frm.submit.value = '  first select action  ';	frm.submit.disabled = true; }
				frm.todo[0].checked = false; frm.todo[0].disabled = true;
				frm.todo[1].disabled = false; frm.todo[2].disabled = false; frm.todo[3].disabled = false;
				for (var i=0;i<frm.elements.length;i++) { var z=frm.elements[i]; if (z.name == 'filename') { z.checked = false } }
			}
			if (z == 'restore')
			{
				frm.todo[0].checked = true; frm.todo[0].disabled = false;
				frm.todo[1].disabled = true; frm.todo[2].disabled = true; frm.todo[3].disabled = true;
				frm.submit.value = 'Restore from backup'; frm.submit.disabled = false;
				for (var i=0;i<frm.elements.length;i++) { var z=frm.elements[i]; if (z.name == 'files') { z.checked = false } }
			}
			if (z == 'delete') { frm.submit.value = 'Delete backups'; frm.submit.disabled = false; }
			if (z == 'emailform') { frm.submit.value = 'Email backups'; frm.submit.disabled = false; }
			if (z == 'ftpform') { frm.submit.value = 'Upload on FTP'; frm.submit.disabled = false; }
		}
		//-->
		</SCRIPT>}.&Header("Backups list of database <i>'$mySQLDBName'</i>").qq{<p><form name="selectdbdumpform" action="backupsmanager.cgi" method="post" onsubmit="return AreYouSure()">
		<input type="hidden" name="db" value="$DB">
		<ul><li><i>Sel</i> | <i>Res</i> | }.uc("<i>$ArchiveExt</i>");
		opendir (DIR, $iDBDumpsDir);
		while ($file = readdir(DIR))
		{
			($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$iDBDumpsDir$DirSeparator$file");
			$mtime = TextDateTime($mtime);
			$result .= qq{<li><input type="checkbox" name="files" value="$file" title="select file" onclick="Boxes('select')"> | <input type="radio" name="filename" value="$file" onclick="Boxes('restore')" title=}.(($file =~ /$ArchiveExt$/)?(qq{"disabled for restore. unpack first" disabled> | <input type="radio" name="$file" title="packed file. click to unpack" onclick="this.checked = false; self.location = 'backupsmanager.cgi?todo=unpackfile&file=$file&db=$DB'" checked>}):(qq{"select for restore"> | <input type="radio"  name="$file" title="click to pack file" onclick="self.location = 'backupsmanager.cgi?todo=packfile&file=$file&db=$DB'">})).qq{ | <a target="_top" title="download file" href="backupsmanager.cgi?todo=downloadfile&file=$file&db=$DB&r=$rand">$file</a> <i>($mtime; size: $size bytes)</i>} if ($file ne '.' and $file ne '..')
		}
		closedir(DIR);
		$result .= qq{
		</ul>
		<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>
		<td width="40%">
		<input type="radio" name="todo" value="restore" disabled> Restore database from backup<br>
		<input type="radio" name="todo" value="delete" onclick="Boxes('delete')" disabled> Delete selected backups
		</td>
		<td>
		<input type="radio" name="todo" value="emailform" onclick="Boxes('emailform')" disabled> Email selected backups<br>
		<input type="radio" name="todo" value="ftpform" onclick="Boxes('ftpform')" disabled> Upload selected backups on FTP server
		</td>
		</tr></table>
		<br><br>
		<input type="submit" name="submit" value="  first select action  " disabled></form></p>}.&Header("Upload backup for database <i>'$mySQLDBName'</i>").qq{
		<p><form name="uploaddbdumpform" action="backupsmanager.cgi" method="post" enctype="multipart/form-data">
		<input type="hidden" name="db" value="$DB">
		<input type="hidden" name="todo" value="upload">
		<input type="file" name="uploadfilename" size="50"><br><br>
		<input type="submit" value="Upload backup">
		</form></p>};
	}

	$result .= &Header('Backup all databases').qq{<p>
	<form action="backupsmanager.cgi" method="post">
	<input type="hidden" name="db" value="$DB">
	<input type="hidden" name="todo" value="backupall">
	<i>filename for backups:</i><br>
	<input type="text" name="filename" value="$filename(bulk).sql" size="47" style="width: 320px;">
	<input type="submit" value="Backup all"><br>
	<input type="checkbox" name="packfile" value="1"> Pack each file after saving
	<input type="checkbox" name="emailfile" value="1"> Email each file
	<input type="checkbox" name="ftpfile" value="1"> Upload each file on FTP server<br>
	</form>
	</p>};

	return $result;
}

sub SendFile
{
	my ($emptyfile) = 'please register indexsoft MySQL backups manager at http://www.indexsoft.com/dbmanagerpro/';
	my ($from, $to, $subject, $body, @files) = @_;
	return $sendmailerror if $sendmailerror;
	$sm = new SendMail($SMTP, $SMTPPort);
	$sm->setDebug($sm->OFF);
	$sm->From($from);
	$sm->Subject($subject);
	$sm->To($to);
	$sm->setMailHeader('X-Mailer', 'indexsoft MySQL backups manager (http://www.indexsoft.com)');
	$body =~ s/\n/\r\n/g;
	$sm->setMailBody("$body\r\n\r\n------------\r\nSent by indexsoft MySQL backups manager (http://www.indexsoft.com)");
	$sm->Attach('readme.txt', \$emptyfile);
	$sm->Attach();
	if ($sm->sendMail() != 0) { return $sm->{'error'} };
	$sm->reset();
	$cron
	? print "email operation is limited at shareware version. An empty message was send.\n"
	: print qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('email operation is limited at shareware version. An empty message was send.')\n//-->\n</SCRIPT>};
	return 0;
}

sub FTPFile
{
	my ($server, $port, $path, $login, $pass, @files) = @_;
	return $ftperror if $ftperror;
	$ftp = Net::FTP->new($server, Debug => 0, Port => $port);
	return $@ if $@;
	$ftp->login($login, $pass);
	return "can not login to <i>'$server'</i>" if !($ftp->pwd());
	$ftp->mkdir("$path/please_register_indexsoft_backups_manager");
	$ftp->cwd("$path/please_register_indexsoft_backups_manager");
	return "can not create directory <i>'please_register_indexsoft_backups_manager'</i> or change remote dir to <i>'please_register_indexsoft_backups_manager'</i>" if ($ftp->pwd() !~ /$path\/please_register_indexsoft_backups_manager/);
	$ftp->quit;
	$cron
	? print "FTP operation is limited at shareware version. indexsoft MySQL backups manager has successfully connected to FTP server but the files were not uploaded.\n"
	: print qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('FTP operation is limited at shareware version. indexsoft MySQL backups manager has successfully connected to FTP server but the files were not uploaded.')\n//-->\n</SCRIPT>};
	return 0;
}

sub CommandLine
{
	return q{
Command line switches:
	
--db=x backup database with number x 
--db=all backup all databases

To pack, email and/or upload created backup(s) on FTP server use following switches:
--pack 
--mail 
--ftp

To change default filename(s) for backup(s) file(s) use following switch:
--filename=mycronbackup.sql

To change default SMTP server, its SMTP port and email address use following switches:
--smtpserver=smtp.host.com 
--smtpport=portnumber 
--email=me@email.com

To change default FTP server, its FTP port, path on FTP server, FTP login and password use following switches:
--ftpserver=ftp.host.com 
--ftpport=portnumber 
--ftppath=/myuploads/backups 
--ftplogin=mylogin 
--ftppaswd=mypassword 

All switches can be used simultaneously and in any order for example:

./backupsmanager.cgi --db=all --filename=cron.sql --pack --mail --ftp --ftppaswd=mypass --email=me@host.com

this will backup all databases to 'cron.sql' files, pack them, upload packed files on default FTP server using password 'mypass' and email them all to email address 'me@host.com' using default SMTP settings.

} if $cron;
	my ($dbcmds, $i) = ();
	for ($i = 0; $i <= $#mySQLDBName; ++$i)
	{
		$dbcmds .= qq{<li><font face="Courier">--db=$i</font> (backup database '$mySQLDBName[$i]')};
	}
	return &Header('Command line parameters').qq{<p>&nbsp;</p><p>To run indexsoft MySQL backups manager from command line (from cron to have scheduled backups for an example) please use following switches:</p>
	<ul>
	$dbcmds
	<li><font face="Courier">--db=all</font> (backup all databases)
	</ul>
	<p>To pack, email and/or upload created backup(s) on FTP server use following switches:</p>
	<ul>
	<li><font face="Courier">--pack</font>
	<li><font face="Courier">--mail</font>
	<li><font face="Courier">--ftp</font>
	</ul>
	<p>To change default filename(s) for backup(s) file(s) use following switch:</p>
	<ul><li><font face="Courier">--filename=mycronbackup.sql</font></ul>
	<p>To change default SMTP server, its SMTP port and email address use following switches:</p>
	<ul>
	<li><font face="Courier">--smtpserver=smtp.host.com</font>
	<li><font face="Courier">--smtpport=portnumber</font>
	<li><font face="Courier">--email=me\@email.com</font>
	</ul>
	<p>To change default FTP server, its FTP port, path on FTP server, FTP login and password use following switches:</p>
	<ul>
	<li><font face="Courier">--ftpserver=ftp.host.com</font>
	<li><font face="Courier">--ftpport=portnumber</font>
	<li><font face="Courier">--ftppath=/myuploads/backups</font>
	<li><font face="Courier">--ftplogin=mylogin</font>
	<li><font face="Courier">--ftppaswd=mypassword</font>
	</ul>
	<p>All switches can be used simultaneously and in any order for example:<br><br>
	<font face="Courier">./backupsmanager.cgi --db=all --filename=cron.sql --pack --mail<br>--ftp --ftppaswd=mypass --email=me\@host.com </font><br><br>	
	this will backup all databases to 'cron.sql' files, pack them, upload packed files on default FTP server using password 'mypass' and email them all to email address 'me\@host.com' using default SMTP settings.</p>
	<p>&nbsp;</p>
	<p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}

sub EditConfigForm
{
	if ($cron)
	{
		$cfgfile = &CfgTemplate();
		open(FILE, ">backupsmanager.pm") || do { print "can not rewrite configuration file 'backupsmanager.pm'\n"; exit; };
		binmode('FILE');
		print FILE $cfgfile;
		close FILE;
		return "create default configuration file backupsmanager.pm. please check-up it carefully and fill in all indispensable variables\n";
	}
	local *IN;
	my $cfgfile, $nofile;
	open(IN, 'backupsmanager.pm') || ($nofile = 1);
	grep ($cfgfile .= $_, <IN>);
	close IN;
	print &HoldError($configerror) if ($configerror and !$P{'autocfg'});
	if ($nofile or $P{'autocfg'})
	{
		print &Operation('generate configuration file automatically');
		$cfgfile = &CfgTemplate();
	}
	return &Header('Edit configuration file').qq{Document root directory: <i>$document_root</i><br>
	Install directory: <i>$installdir</i><br><br>
	&#149; <a href="backupsmanager.cgi?todo=configure&db=$DB&autocfg=1" onclick="return window.confirm('Please confirm the action only if backups manager does not work correctly\\nAre you shure?')">Generate configuration file automatically</a><br>
	&#149; <a href="backupsmanager.cgi?todo=configure&db=$DB&autocfg=1&upgrade=1" onclick="return window.confirm('This action will add new variables to configuration file if they does not exist, but do not overwrite defined variables.\\nAre you shure?')">Upgrade old version configuration file</a><br><br>
	<form action="backupsmanager.cgi" method="post">
	<input type="hidden" name="todo" value="saveconfig">
	<input type="hidden" name="db" value="$DB">
	<textarea cols="66" rows="15" name="cfgfilecontent" wrap="off">$cfgfile</textarea><br><br>
	<table width="550" border="0" cellspacing="0" cellpadding="0"><tr><td><input type="submit" value="Save configuration file"></td><td  align="right"><input type="reset" value="Reset all changes"></td></tr></table>
	</form>
	<p><a href="backupsmanager.cgi?db=$DB">&laquo;&laquo; return back</a></p>};
}

sub CfgTemplate
{
my $dirsep = '/'; $dirsep = '\\\\' if ($ENV{'WINDIR'});
my $upg = $P{'upgrade'};
my ($result, $i);

my $dbdumpcmd = 'NOT_DETECTED';
if (-e '\mysql\bin\mysqldump.exe') { $dbdumpcmd = '\mysql\bin\mysqldump.exe' }
elsif (-e 'c:\mysql\bin\mysqldump.exe') { $dbdumpcmd = 'c:\mysql\bin\mysqldump.exe' }
elsif (-e 'd:\mysql\bin\mysqldump.exe') { $dbdumpcmd = 'd:\mysql\bin\mysqldump.exe' }
elsif (-e 'e:\mysql\bin\mysqldump.exe') { $dbdumpcmd = 'e:\mysql\bin\mysqldump.exe' }
elsif (-e '\webshare\mysql\bin\mysqldump.exe') { $dbdumpcmd = '\webshare\mysql\bin\mysqldump.exe' }
elsif (-e '/usr/local/bin/mysqldump') { $dbdumpcmd = '/usr/local/bin/mysqldump' }
elsif (-e '/usr/local/mysql/bin/mysqldump') { $dbdumpcmd = '/usr/local/mysql/bin/mysqldump' }
elsif (-e '/usr/mysql/bin/mysqldump') { $dbdumpcmd = '/usr/mysql/bin/mysqldump' }
elsif (-e '/usr/bin/mysqldump') { $dbdumpcmd = '/usr/bin/mysqldump' };

my $dbrestcmd = 'NOT_DETECTED';
if (-e '\mysql\bin\mysql.exe') { $dbrestcmd = '\mysql\bin\mysql.exe' }
elsif (-e 'c:\mysql\bin\mysql.exe') { $dbrestcmd = 'c:\mysql\bin\mysql.exe' }
elsif (-e 'd:\mysql\bin\mysql.exe') { $dbrestcmd = 'd:\mysql\bin\mysql.exe' }
elsif (-e 'e:\mysql\bin\mysql.exe') { $dbrestcmd = 'e:\mysql\bin\mysql.exe' }
elsif (-e '\webshare\mysql\bin\mysql.exe') { $dbrestcmd = '\webshare\mysql\bin\mysql.exe' }
elsif (-e '/usr/local/bin/mysql') { $dbrestcmd = '/usr/local/bin/mysql' }
elsif (-e '/usr/local/mysql/bin/mysql') { $dbrestcmd = '/usr/local/mysql/bin/mysql' }
elsif (-e '/usr/mysql/bin/mysql') { $dbrestcmd = '/usr/mysql/bin/mysql' }
elsif (-e '/usr/bin/mysql') { $dbdumpcmd = '/usr/bin/mysql' };

my $archivercmd = 'NOT_DETECTED';
my $archiveext = 'NOT_DETECTED';
my $dearchivercmd = 'NOT_DETECTED';
if ($ENV{'WINDIR'})
{
	if (-e 'c:\program files\winrar\rar.exe')
	{
		$archivercmd = '"c:\program files\winrar\rar.exe" a -inul -df -y -ep "%a%" "%f%"';
		$dearchivercmd = '"c:\program files\winrar\rar.exe" e -inul -y "%a%" %p%';
		$archiveext = 'rar';
	}
}
else
{
	$archivercmd = 'gzip -9 -q -f "%f%"';
	$dearchivercmd = 'gunzip -q -f "%a%"';
	$archiveext = 'gz';
}


$result = q{# ATTENTION!!! AUTOMATICALLY GENERATED CONFIGURATION FILE
# PLEASE CHECK-UP CAREFULLY AND FILL IN ALL INDISPENSABLE VARIABLES
# if some of executables files was not detected automatically, you can use
# free indexsoft files searcher to find them fast and easy
# check downloads page at http://www.indexsoft.com/

# arrays @mySQLDBName, @mySQLHost, @mySQLUser and @mySQLPassword
# contains lists of MySQL databases, MySQL hosts, MySQL users
# and their passwords accordingly};

if (($#mySQLDBName >= 0) and $upg)
{
for ($i = 0; $i <= $#mySQLDBName; ++$i) 
{
$result .= qq{
\$mySQLDBName[$i] = '$mySQLDBName[$i]';
\$mySQLHost[$i] = '$mySQLHost[$i]';
\$mySQLUser[$i] = '$mySQLUser[$i]';
\$mySQLPassword[$i] = '$mySQLPassword[$i]';\n}
}
}
else
{
$result .= q{
$mySQLDBName[0] = 'mydb0';
$mySQLHost[0] = 'localhost';
$mySQLUser[0] = 'username';
$mySQLPassword[0] = 'password';

$mySQLDBName[1] = 'mydb1';
$mySQLHost[1] = 'another_host';
$mySQLUser[1] = 'username';
$mySQLPassword[1] = 'password';}
}

$result .= q{

# complete path to directory where to store MySQL backups, leave out trailing "\\" or "/"
$DBDumpsDir = '}.(($DBDumpsDir and $upg)?("$DBDumpsDir"):("$installdir")).q{';

# full path and a name of the executable file which is delivered with distribution
# of MySQL and which makes a dump of the selected database
$DumpDBCommand = '}.(($DumpDBCommand and $upg)?("$DumpDBCommand"):("$dbdumpcmd")).q{';

# full path and a name of the executable file which restore selected database
# (from distribution of MySQL)
$RestoreDBCommand = '}.(($RestoreDBCommand and $upg)?("$RestoreDBCommand"):("$dbrestcmd")).q{';

# full path (if required) and name of the archiver
# %f% - defines file to pack, %a% - defines filename of archive
# for example (WinRAR usage under Windows):
# $ArchiverCommand = '"c:\program files\winrar\rar.exe" a -df -inul -ep -y "%a%" "%f%"';
# for example (gzip on *nix):
# $ArchiverCommand = 'gzip -9 -q -f "%f%"' or 'gzip -9 -q -f -c "%f%" > "%a%"';
$ArchiverCommand = '}.(($ArchiverCommand and $upg)?("$ArchiverCommand"):("$archivercmd")).q{';

# full path (if required) and name of the dearchiver
# %p% - path to extract, %a% - defines filename of archive
# for example (WinRAR usage under Windows):
# $DeArchiverCommand = '"c:\program files\winrar\rar.exe" e -inul -y "%a%" %p%';
# for example (gzip on *nix):
# $DeArchiverCommand = 'gunzip -q -f "%a%"';
$DeArchiverCommand = '}.(($DeArchiverCommand and $upg)?("$DeArchiverCommand"):("$dearchivercmd")).q{';

# file extension for archives, for example: 'gz' if *nix gzip or 'rar' if winar
$ArchiveExt = '}.(($ArchiveExt and $upg)?("$ArchiveExt"):("$archiveext")).q{';

# default email address on which one the DB's backup files will be send
$DefaultEmail = '}.(($DefaultEmail and $upg)?("$DefaultEmail"):("$ENV{'SERVER_ADMIN'}")).q{';

# SMTP server for sending email (default - localhost). indexsoft backups manager uses
# sendmail.pm (http://www.tneoh.zoneit.com/perl/SendMail/) to send email
# if sendmail.pm can not connect to SMTP host you can use patched sendmail.pm, wich can use a program
# to send emails (for example sendmail for linux). In this case type in here command line and parameters
# of a program (for example to use linux sendmail: $SMTP = '|/usr/sbin/sendmail -t');
# check downloads page at http://www.indexsoft.com/ to download patched sendmail.pm
# to install sendmail.pm you can just copy it in the same directory where backups manager is
$SMTP = '}.(($SMTP and $upg)?("$SMTP"):('localhost')).q{';

# SMTP port (default 25)
$SMTPPort = '}.(($SMTPPort and $upg)?("$SMTPPort"):('25')).q{';

# Default FTP server
$DefaultFTP = '}.(($DefaultFTP and $upg)?("$DefaultFTP"):('')).q{';

# Default FTP server port
$DefaultFTPPort = '}.(($DefaultFTPPort and $upg)?("$DefaultFTPPort"):('21')).q{';

# Default path on FTP server, leave out trailing "/"
$DefaultFTPPath = '}.(($DefaultFTPPath and $upg)?("$DefaultFTPPath"):('')).q{';

# Default login to access FTP server
$DefaultFTPLogin = '}.(($DefaultFTPLogin and $upg)?("$DefaultFTPLogin"):('')).q{';

# Default password to access FTP server
$DefaultFTPPass = '}.(($DefaultFTPPass and $upg)?("$DefaultFTPPass"):('')).q{';

# $DirSeparator must be '\\\\' if script runs at windows of '/' for *nux 
$DirSeparator = '}.$dirsep.q{';

1; # DO NOT DELETE THIS LINE
};
return $result;
}

sub DefineParams
{
 	if ($_[0] =~ /^\d+$/)
	{
		$DB = $_[0];
	 	$mySQLDBName = $mySQLDBName[$DB];
		$mySQLHost = $mySQLHost[$DB];
		$mySQLUser = $mySQLUser[$DB];
		$mySQLPassword = $mySQLPassword[$DB];
		$iDumpDBCommand = "$DumpDBCommand --host=$mySQLHost --user=$mySQLUser --password=$mySQLPassword --add-drop-table $mySQLDBName";
		$iRestoreDBCommand = "$RestoreDBCommand --host=$mySQLHost --user=$mySQLUser --password=$mySQLPassword $mySQLDBName";
		$iDBDumpsDir = "$DBDumpsDir$DirSeparator$mySQLHost---$mySQLDBName";
		if ($mySQLDBName) { mkdir ($iDBDumpsDir, '0777'); chmod (0777, $iDBDumpsDir); }
	}
	else
	{
		undef $DB;
	 	undef $mySQLDBName;
		undef $mySQLHost;
		undef $mySQLUser;
		undef $mySQLPassword;
		undef $iDumpDBCommand;
		undef $iRestoreDBCommand;
		undef $iDBDumpsDir;
	}
}

sub TopOfPage
{
	$cron
	? return "indexsoft MySQL backups manager (ver. $VER)\nstarted at ".&TextDateTime(time)."\n"
	: return qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n<html>
	<head>
	<title>indexsoft MySQL backups manager (ver. $VER)</title>
	<style type="text/css">
		body,p,input,td { font-size : 13px; color : Black; font-family : Arial, Helvetica, sans-serif; }
		p { margin-top : 0px; margin-bottom : 5px; }
		H4 { color : #5588BB; font-size : 16px;}
		body a { text-decoration : none; }
		body a:hover { text-decoration : underline; }
		body .small { font-size : 11px; text-align: right;}
		body .small2 { font-size : 11px; text-align: left;}
	</style>
	</head>
	
	<body bgcolor="White">
	<center>
	<table width="600" border="0" cellspacing="0" cellpadding="0"><tr><td>
	<center>
	<h4>indexsoft MySQL backups manager</h4>
	<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table bgcolor="#ffffff" width="100%" border="0" cellspacing="0" cellpadding="5"><tr><td>};
}

sub BottomOfPage
{
	$cron
	? return 'stoped at '.&TextDateTime(time)."\n"
	:	return qq{</td></tr></table></td></tr></table><div class=small><a href="backupsmanager.cgi?todo=configure&db=$DB">configuration file</a> | <a href="backupsmanager.cgi?todo=commandline&db=$DB">command line</a> | <a href="backupsmanager.cgi?todo=checkver&db=$DB">check new version</a> | <a href="http://www.indexsoft.com">www.indexsoft.com</a></div>
	<!------- Start of HTML Code ------->
	<form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST" target="_new">
	<input type="hidden" name="ID" value="16662"><a href="http://www.hotscripts.com/Detailed/16662.html" target="_new">rate backups manager at HotScripts.com</a><br>
	<select name="ex_rate" size="1"><option selected>Select</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select>
	<input type="submit" value="Go!"></form>
	<!------- End of HTML Code ------->
	<!-- --------- Start of ScriptSearch Rating Code --------- -->
	<form action="http://www.scriptsearch.com/cgi-bin/rateit.cgi" method="post" target="_new">
	<input type="hidden" name="ID" value="5691">
	<a href="http://www.scriptsearch.com/details/5691.html" target="_new">rate backups manager at ScriptSearch.com</a><br>
	<select name="rate" size="1"><option value="--">- Select -</option><option value="5">Excellent!</option><option value="4">Very Good</option><option value="3">Good</option><option value="2">Fair</option><option value="1">Poor</option></select>
	<input type="submit" value="Go!"></form>
	<!-- --------- End of ScriptSearch Rating Code --------- -->
	<hr size="1" noshade>
	<p><font size="1">(note: rating forms removed from full version)</font></p>
	</td></tr></table></body></html>};
}

sub Operation
{
	$cron
	? do { $_[0] =~ s/<br>/\n/g; $_[0] =~ s/<[^<>]*>//g; return "Action: $_[0]\n" }
	: return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#C3D5E7"><tr><td valign="top" width="1%"><b>Action:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub Header
{
	$cron
	? return ''
	: return qq{<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#F0F0F0"><tr><td>$_[0]</td></tr></table></td></tr></table>};
}

sub HoldError
{
	$cron
	? do { $_[0] =~ s/<br>/\n/g; $_[0] =~ s/<[^<>]*>//g; return "Error: $_[0]\n" }
	: return qq{<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">\n<!--\nalert('Error occured!')\n//-->\n</SCRIPT>\n<table width="100%" bgcolor="#808080" border="0" cellspacing="0" cellpadding="1"><tr><td><table width="100%" border="0" cellspacing="0" cellpadding="2" bgcolor="#FFCDCD"><tr><td valign="top" width="1%"><b>Error:</b></td><td width="99%">$_[0]</td></tr></table></td></tr></table><br>};
}

sub TextDate
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	$year = 1900+$year;
	++$mon;
	if (length($mon)==1) {$mon="0$mon"};
	if (length($mday)==1) {$mday="0$mday"};
	$_ = "$year-$mon-$mday";
}

sub TextDateTime
{
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	my(@mons) = ('January', 'February', 'March', 'April', 'May', 'June', 'Jule', 'August', 'September', 'October', 'November', 'December');
	$year = 1900+$year;
	$_ = "$mday $mons[$mon] $year; $hour\:$min\:$sec";
}

sub ReadParameters
{
	if ($cron)
	{
		my ($line) = ();
		$P{'todo'} = 'commandline' if !$configerror;
		foreach $line(@ARGV)
		{
			# --db=1(2...)
			if ($line =~ '^--db=(\d+)$') { $P{'db'} = $1; $P{'todo'} = 'dumpandsave'; }
			# --db=all
			elsif ($line =~ '^--db=all$') { $P{'todo'} = 'backupall'; }
			# --pack
			elsif ($line =~ '^--pack$') { $P{'packfile'} = 1; }
			# --mail
			elsif ($line =~ '^--mail$') { $P{'emailfile'} = 1; }
			# --email=email@mmmm.com
			elsif ($line =~ '^--email=(.*)$') { $DefaultEmail = $1; }
			# --smtpserver=server
			elsif ($line =~ '^--smtpserver=(.*)$') { $SMTP = $1; }
			# --smtpport=port
			elsif ($line =~ '^--smtpport=(.*)$') { $SMTPPort = $1; }
			# --ftp
			elsif ($line =~ '^--ftp$') { $P{'ftpfile'} = 1; }
			# --ftpserver=server
			elsif ($line =~ '^--ftpserver=(.*)$') { $DefaultFTP = $1; }
			# --ftpport=port
			elsif ($line =~ '^--ftpport=(.*)$') { $DefaultFTPPort = $1; }
			# --ftppath=path
			elsif ($line =~ '^--ftppath=(.*)$') { $DefaultFTPPath = $1; }
			# --ftplogin=login
			elsif ($line =~ '^--ftplogin=(.*)$') { $DefaultFTPLogin = $1; }
			# --ftppaswd=password
			elsif ($line =~ '^--ftppaswd=(.*)$') { $DefaultFTPPass = $1; }
			# --filename=filename
			elsif ($line =~ '^--filename=(.*)$') { $P{'filename'} = $1; }
		}
	}
	else
	{
		use CGI;
		$MULTIPARTQUERY = new CGI;
		my @params = $MULTIPARTQUERY->param;
		my ($line);
		foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); }
	}
}

